#include <iostream>
#include <stdlib.h>
#include <string>
using namespace std;

class Person
{
public:
  virtual void fv1()
  {
    cout << "Person::fv1" << endl;
  }
  void fv2()
  {
    cout << "Person::fv2" << endl;
  }
};

class Employee : public Person
{
public:
  void fv1()
  {
    cout << "Employee::fv1" << endl;
  }
  virtual void fv2()
  {
    cout << "Employee::fv2" << endl;
  }
};

class Manager : public Employee
{
public:
  void fv1()
  {
    cout << "Manager::fv1" << endl;
  }
  void fv2()
  {
    cout << "Manager::fv2" << endl;
  }
};

int main()
{
  Person * p1;
  p1 = new Manager;
  p1 -> fv1();
  p1 -> fv2();
  delete p1;
  Employee * e1;
  e1 = new Manager;
  e1 -> fv1();
  e1 -> fv2();
  delete e1;
  return 0;
}
